'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var store = require('solid-js/store');
var solidJs = require('solid-js');
var _isEqual = require('fast-deep-equal/es6');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _isEqual__default = /*#__PURE__*/_interopDefaultLegacy(_isEqual);

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);

  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    enumerableOnly && (symbols = symbols.filter(function (sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    })), keys.push.apply(keys, symbols);
  }

  return keys;
}

function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = null != arguments[i] ? arguments[i] : {};
    i % 2 ? ownKeys(Object(source), !0).forEach(function (key) {
      _defineProperty(target, key, source[key]);
    }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) {
      Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
    });
  }

  return target;
}

function _typeof(obj) {
  "@babel/helpers - typeof";

  return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) {
    return typeof obj;
  } : function (obj) {
    return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
  }, _typeof(obj);
}

function _defineEnumerableProperties(obj, descs) {
  for (var key in descs) {
    var desc = descs[key];
    desc.configurable = desc.enumerable = true;
    if ("value" in desc) desc.writable = true;
    Object.defineProperty(obj, key, desc);
  }

  if (Object.getOwnPropertySymbols) {
    var objectSymbols = Object.getOwnPropertySymbols(descs);

    for (var i = 0; i < objectSymbols.length; i++) {
      var sym = objectSymbols[i];
      var desc = descs[sym];
      desc.configurable = desc.enumerable = true;
      if ("value" in desc) desc.writable = true;
      Object.defineProperty(obj, sym, desc);
    }
  }

  return obj;
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}

function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
}

function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) return _arrayLikeToArray(arr);
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArray(iter) {
  if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter);
}

function _iterableToArrayLimit(arr, i) {
  var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"];

  if (_i == null) return;
  var _arr = [];
  var _n = true;
  var _d = false;

  var _s, _e;

  try {
    for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

function _createForOfIteratorHelper(o, allowArrayLike) {
  var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"];

  if (!it) {
    if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") {
      if (it) o = it;
      var i = 0;

      var F = function () {};

      return {
        s: F,
        n: function () {
          if (i >= o.length) return {
            done: true
          };
          return {
            done: false,
            value: o[i++]
          };
        },
        e: function (e) {
          throw e;
        },
        f: F
      };
    }

    throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }

  var normalCompletion = true,
      didErr = false,
      err;
  return {
    s: function () {
      it = it.call(o);
    },
    n: function () {
      var step = it.next();
      normalCompletion = step.done;
      return step;
    },
    e: function (e) {
      didErr = true;
      err = e;
    },
    f: function () {
      try {
        if (!normalCompletion && it.return != null) it.return();
      } finally {
        if (didErr) throw err;
      }
    }
  };
}

// *****************************
// Misc Types
// *****************************
// *****************************
// AbstractControl interface
// *****************************
var AbstractControlInterface = '@@AbstractControlInterface_solidjs';
/** Returns true if the provided object implements `IAbstractControl` */

function isAbstractControl(object) {
  return _typeof(object) === 'object' && (object === null || object === void 0 ? void 0 : object[AbstractControlInterface]) === true;
}

var AbstractControlContainerInterface = '@@AbstractControlContainerInterface_solidjs';
/**
 * Returns true if the provided object implements
 * `IAbstractControlContainer`
 */

function isAbstractControlContainer(object) {
  return isAbstractControl(object) && object[AbstractControlContainerInterface];
}

function isEqual(a, b) {
  return _isEqual__default["default"](a, b);
}
function mergeObj(a, b) {
  return Object.defineProperties(a, Object.getOwnPropertyDescriptors(b));
}
/**
 * Helper to bind the owner of the current context to the
 * supplied function.
 *
 * Implementation is very simple:
 * ```ts
 * import { getOwner, runWithOwner } from 'solid-js';
 *
 * export function bindOwner<T>(fn: () => T): () => T {
 *   const owner = getOwner();
 *
 *   if (!owner) {
 *     throw new Error('No solidjs owner in current context');
 *   }
 *
 *   return () => runWithOwner(owner, fn);
 * }
 * ```
 */

function bindOwner(fn) {
  var owner = solidJs.getOwner();

  if (!owner) {
    throw new Error('No solidjs owner in current context');
  }

  return function () {
    return solidJs.runWithOwner(owner, fn);
  };
}

var DEFAULT_SOURCE = 'CONTROL_DEFAULT_SOURCE';
function propInitializer() {
  var _createSignal = solidJs.createSignal(null),
      _createSignal2 = _slicedToArray(_createSignal, 2),
      initializationSignal = _createSignal2[0],
      setInitializationSignal = _createSignal2[1];

  return [function (value) {
    return initializationSignal() || value;
  }, function () {
    return setInitializationSignal(false);
  }];
}
function composeValidators(validators) {
  if (!validators || Array.isArray(validators) && validators.length === 0) {
    return null;
  }

  if (Array.isArray(validators)) {
    return function (control) {
      return validators.reduce(function (prev, curr) {
        var errors = curr(control);
        return errors ? _objectSpread2(_objectSpread2({}, prev), errors) : prev;
      }, null);
    };
  }

  return validators;
}
var controlId = 0;
function createAbstractControlBase(store$1, untilInit) {
  var initOptions = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  var control;
  var setControl;
  var selfIsPendingMemo;
  var selfErrorsMemo;
  var statusMemo;
  var validatorMemo;
  var base = {
    id: initOptions.id || Symbol("AbstractControl-".concat(controlId++)),
    data: _objectSpread2({}, initOptions.data),
    self: {
      get isValid() {
        // here "this" is self
        return this.errors === null && !this.isPending;
      },

      isDisabled: false,
      isTouched: false,
      isDirty: false,
      isReadonly: false,
      isSubmitted: false,
      isRequired: false,

      get isPending() {
        var _selfIsPendingMemo, _selfIsPendingMemo2;

        return (_selfIsPendingMemo = (_selfIsPendingMemo2 = selfIsPendingMemo) === null || _selfIsPendingMemo2 === void 0 ? void 0 : _selfIsPendingMemo2()) !== null && _selfIsPendingMemo !== void 0 ? _selfIsPendingMemo : untilInit(false);
      },

      get errors() {
        var _selfErrorsMemo, _selfErrorsMemo2;

        return (_selfErrorsMemo = (_selfErrorsMemo2 = selfErrorsMemo) === null || _selfErrorsMemo2 === void 0 ? void 0 : _selfErrorsMemo2()) !== null && _selfErrorsMemo !== void 0 ? _selfErrorsMemo : untilInit(null);
      },

      errorsStore: new Map(),
      pendingStore: new Set(),
      validatorStore: new Map()
    },

    get isDisabled() {
      return this.self.isDisabled;
    },

    get isTouched() {
      return this.self.isTouched;
    },

    get isDirty() {
      return this.self.isDirty;
    },

    get isReadonly() {
      return this.self.isReadonly;
    },

    get isSubmitted() {
      return this.self.isSubmitted;
    },

    get isRequired() {
      return this.self.isRequired;
    },

    get errors() {
      return this.self.errors;
    },

    get isPending() {
      return this.self.isPending;
    },

    get isValid() {
      return this.self.isValid;
    },

    get status() {
      var _statusMemo, _statusMemo2;

      return (_statusMemo = (_statusMemo2 = statusMemo) === null || _statusMemo2 === void 0 ? void 0 : _statusMemo2()) !== null && _statusMemo !== void 0 ? _statusMemo : untilInit('VALID');
    },

    get validator() {
      var _validatorMemo, _validatorMemo2;

      return (_validatorMemo = (_validatorMemo2 = validatorMemo) === null || _validatorMemo2 === void 0 ? void 0 : _validatorMemo2()) !== null && _validatorMemo !== void 0 ? _validatorMemo : untilInit(null);
    },

    markDisabled: function markDisabled(input) {
      if (isEqual(this.self.isDisabled, input)) return;
      setControl('self', 'isDisabled', input);
    },
    markReadonly: function markReadonly(input) {
      if (isEqual(this.self.isReadonly, input)) return;
      setControl('self', 'isReadonly', input);
    },
    markRequired: function markRequired(input) {
      if (isEqual(this.self.isRequired, input)) return;
      setControl('self', 'isRequired', input);
    },
    markDirty: function markDirty(input) {
      if (isEqual(this.self.isDirty, input)) return;
      setControl('self', 'isDirty', input);
    },
    markTouched: function markTouched(input) {
      if (isEqual(this.self.isTouched, input)) return;
      setControl('self', 'isTouched', input);
    },
    markSubmitted: function markSubmitted(input) {
      if (isEqual(this.self.isSubmitted, input)) return;
      setControl('self', 'isSubmitted', input);
    },
    markPending: function markPending(input, options) {
      var newPendingStore;

      if (typeof input === 'boolean') {
        var source = (options === null || options === void 0 ? void 0 : options.source) || DEFAULT_SOURCE;
        if (this.self.pendingStore.has(source) === input) return;
        newPendingStore = new Set(this.self.pendingStore);

        if (input) {
          newPendingStore.add(source);
        } else {
          newPendingStore["delete"](source);
        }
      } else {
        if (this.self.pendingStore === input) return;
        newPendingStore = new Set(input);
      }

      if (isEqual(this.self.pendingStore, newPendingStore)) return; // We're using `produce()` here because using the standard solid Store
      // nested setter has some bugs (i.e.
      // `setControl('self', 'pendingStore', newPendingStore)`). I think the
      // bugs are isolated to object values, so, at the moment, I'm only using
      // produce where the value is an object.

      setControl(store.produce(function (state) {
        state.self.pendingStore = newPendingStore;
      }));
    },
    setErrors: function setErrors(input, options) {
      var source = (options === null || options === void 0 ? void 0 : options.source) || DEFAULT_SOURCE;
      var existingStore = this.self.errorsStore;
      var newErrorsStore;

      if (input instanceof Map) {
        newErrorsStore = input;
      } else if (input === null || Object.keys(input).length === 0) {
        newErrorsStore = new Map(existingStore);
        newErrorsStore["delete"](source);
      } else {
        newErrorsStore = new Map(existingStore).set(source, input);
      }

      if (isEqual(this.self.errorsStore, newErrorsStore)) return; // We're using `produce()` here because using the standard solid Store
      // nested setter has some bugs (i.e.
      // `setControl('self', 'pendingStore', newPendingStore)`). I think the
      // bugs are isolated to object values, so, at the moment, I'm only using
      // produce where the value is an object.

      setControl(store.produce(function (state) {
        state.self.errorsStore = newErrorsStore;
      }));
    },
    patchErrors: function patchErrors(input, options) {
      var existingStore = this.self.errorsStore;

      if (input instanceof Map) {
        // We're using `produce()` here because using the standard solid Store
        // nested setter has some bugs (i.e.
        // `setControl('self', 'pendingStore', newPendingStore)`). I think the
        // bugs are isolated to object values, so, at the moment, I'm only using
        // produce where the value is an object.
        setControl(store.produce(function (state) {
          state.self.errorsStore = new Map([].concat(_toConsumableArray(existingStore), _toConsumableArray(input)));
        }));
      } else {
        if (Object.keys(input).length === 0) return;
        var source = (options === null || options === void 0 ? void 0 : options.source) || DEFAULT_SOURCE;
        var newErrors = input;
        var existingValue = existingStore.get(source);

        if (existingValue) {
          existingValue = _objectSpread2({}, existingValue);

          for (var _i = 0, _Object$entries = Object.entries(newErrors); _i < _Object$entries.length; _i++) {
            var _Object$entries$_i = _slicedToArray(_Object$entries[_i], 2),
                k = _Object$entries$_i[0],
                err = _Object$entries$_i[1];

            if (err === null) {
              delete existingValue[k];
            } else {
              existingValue[k] = err;
            }
          }

          newErrors = existingValue;
        } else {
          var entries = Object.entries(newErrors).filter(function (_ref) {
            var _ref2 = _slicedToArray(_ref, 2),
                v = _ref2[1];

            return v !== null;
          });
          if (entries.length === 0) return;
          newErrors = Object.fromEntries(entries);
        }

        var newErrorsStore = new Map(existingStore);

        if (Object.keys(newErrors).length === 0) {
          newErrorsStore["delete"](source);
        } else {
          newErrorsStore.set(source, newErrors);
        }

        if (isEqual(this.self.errorsStore, newErrorsStore)) return; // We're using `produce()` here because using the standard solid Store
        // nested setter has some bugs (i.e.
        // `setControl('self', 'pendingStore', newPendingStore)`). I think the
        // bugs are isolated to object values, so, at the moment, I'm only using
        // produce where the value is an object.

        setControl(store.produce(function (state) {
          state.self.errorsStore = newErrorsStore;
        }));
      }
    },
    setValidators: function setValidators(input, options) {
      var source = (options === null || options === void 0 ? void 0 : options.source) || DEFAULT_SOURCE;
      var newValidatorsStore;

      if (input instanceof Map) {
        newValidatorsStore = new Map(input);
      } else {
        newValidatorsStore = new Map(this.self.validatorStore);
        var newValidator = composeValidators(input);

        if (newValidator) {
          newValidatorsStore.set(source, newValidator);
        } else {
          newValidatorsStore["delete"](source);
        }
      }

      if (isEqual(this.self.validatorStore, newValidatorsStore)) return; // We're using `produce()` here because using the standard solid Store
      // nested setter has some bugs (i.e.
      // `setControl('self', 'pendingStore', newPendingStore)`). I think the
      // bugs are isolated to object values, so, at the moment, I'm only using
      // produce where the value is an object.

      setControl(store.produce(function (state) {
        state.self.validatorStore = newValidatorsStore;
      }));
    },
    setData: function setData(key, input) {
      if (isEqual(this.data[key], input)) return; // We're using `produce()` here because using the standard solid Store
      // nested setter has some bugs (i.e.
      // `setControl('self', 'pendingStore', newPendingStore)`). I think the
      // bugs are isolated to object values, so, at the moment, I'm only using
      // produce where the value is an object.

      setControl(store.produce(function (state) {
        state.data[key] = input;
      }));
    }
  };

  var initializer = function initializer() {
    var _store = store$1();

    var _store2 = _slicedToArray(_store, 2);

    control = _store2[0];
    setControl = _store2[1];
    selfIsPendingMemo = solidJs.createMemo(function () {
      return control.self.pendingStore.size > 0;
    });
    selfErrorsMemo = solidJs.createMemo(function () {
      return control.self.errorsStore.size === 0 ? null : Array.from(control.self.errorsStore.values()).reduce(function (p, errors) {
        return _objectSpread2(_objectSpread2({}, p), errors);
      }, {});
    });
    statusMemo = solidJs.createMemo(function () {
      return control.isDisabled ? 'DISABLED' : control.isPending ? 'PENDING' : control.isValid ? 'VALID' : 'INVALID';
    });
    validatorMemo = solidJs.createMemo(function () {
      if (control.self.validatorStore.size === 0) return null;
      var validators = Array.from(control.self.validatorStore.values());
      return function (c) {
        var e = validators.reduce(function (err, v) {
          return _objectSpread2(_objectSpread2({}, err), v(c));
        }, {});
        return Object.keys(e).length === 0 ? null : e;
      };
    }); // Intentionally not using `createRenderEffect()` since it appears to
    // mess with initializing a control with errors (i.e. it clears the errors
    // after the control is initialized)

    solidJs.createComputed(solidJs.on(function () {
      var _control$validator, _control$validator2, _control;

      return (_control$validator = (_control$validator2 = (_control = control).validator) === null || _control$validator2 === void 0 ? void 0 : _control$validator2.call(_control, control.rawValue)) !== null && _control$validator !== void 0 ? _control$validator : null;
    }, function (errors) {
      if (control.self.errorsStore.get(DEFAULT_SOURCE) === errors) return;
      var newErrorsStore = new Map(control.self.errorsStore);

      if (errors) {
        newErrorsStore.set(DEFAULT_SOURCE, errors);
      } else {
        newErrorsStore["delete"](DEFAULT_SOURCE);
      }

      if (isEqual(control.self.errorsStore, newErrorsStore)) return; // We're using `produce()` here because using the standard solid Store
      // nested setter has some bugs (i.e.
      // `setControl('self', 'pendingStore', newPendingStore)`). I think the
      // bugs are isolated to object values, so, at the moment, I'm only using
      // produce where the value is an object.

      setControl(store.produce(function (state) {
        state.self.errorsStore = newErrorsStore;
      }));
    }));
  };

  return [base, initializer];
}

var FormControlInterface = '@@FormControlInterface_solidjs';

/**
 * Returns true if the provided object implements
 * `IFormControl`
 */
function isFormControl(object) {
  return isAbstractControl(object) && (object === null || object === void 0 ? void 0 : object[FormControlInterface]) === true;
}
function createFormControl(initValue) {
  var _value, _mergeObj, _mutatorMap;

  var initOptions = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var control;
  var setControl;

  var _propInitializer = propInitializer(),
      _propInitializer2 = _slicedToArray(_propInitializer, 2),
      untilInit = _propInitializer2[0],
      initComplete = _propInitializer2[1];

  var _createAbstractContro = createAbstractControlBase(function () {
    return [control, setControl];
  }, untilInit, initOptions),
      _createAbstractContro2 = _slicedToArray(_createAbstractContro, 2),
      base = _createAbstractContro2[0],
      initializeBase = _createAbstractContro2[1];

  var storeConfig = mergeObj(base, (_mergeObj = {}, _defineProperty(_mergeObj, AbstractControlInterface, true), _defineProperty(_mergeObj, FormControlInterface, true), _defineProperty(_mergeObj, "rawValue", initValue), _value = "value", _mutatorMap = {}, _mutatorMap[_value] = _mutatorMap[_value] || {}, _mutatorMap[_value].get = function () {
    return this.rawValue;
  }, _defineProperty(_mergeObj, "setValue", function setValue(value) {
    if (isEqual(this.value, value)) return; // We're using `produce()` here because using the standard solid Store
    // nested setter has some bugs (i.e.
    // `setControl('self', 'pendingStore', newPendingStore)`). I think the
    // bugs are isolated to object values, so, at the moment, I'm only using
    // produce where the value could be an object.

    setControl(store.produce(function (state) {
      state.rawValue = value;
    }));
  }), _defineEnumerableProperties(_mergeObj, _mutatorMap), _mergeObj));

  var _createStore = store.createStore(storeConfig);

  var _createStore2 = _slicedToArray(_createStore, 2);

  control = _createStore2[0];
  setControl = _createStore2[1];
  initializeBase();
  initComplete(); // Intentionally not using `batch()` since it appears to mess with
  // initializing a control with errors

  if (initOptions.disabled) control.markDisabled(initOptions.disabled);
  if (initOptions.touched) control.markTouched(initOptions.touched);
  if (initOptions.dirty) control.markDirty(initOptions.dirty);
  if (initOptions.readonly) control.markReadonly(initOptions.readonly);
  if (initOptions.submitted) control.markSubmitted(initOptions.submitted);
  if (initOptions.required) control.markRequired(initOptions.required);
  if (initOptions.pending) control.markPending(initOptions.pending);
  if (initOptions.validators) control.setValidators(initOptions.validators);
  if (initOptions.pending) control.markPending(initOptions.pending); // this needs to be last to ensure that the errors aren't overwritten

  if (initOptions.errors) control.patchErrors(initOptions.errors);
  return control;
}

function createAbstractControlContainerBase(store$1, untilInit) {
  var initOptions = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  var control;
  var setControl;

  var _createAbstractContro = createAbstractControlBase(function () {
    return [control, setControl];
  }, untilInit, initOptions),
      _createAbstractContro2 = _slicedToArray(_createAbstractContro, 2),
      base = _createAbstractContro2[0],
      initializeAbstractControl = _createAbstractContro2[1];

  var sizeMemo;
  var childIsValidMemo;
  var childIsDisabledMemo;
  var childIsReadonlyMemo;
  var childIsRequiredMemo;
  var childIsPendingMemo;
  var childIsTouchedMemo;
  var childIsDirtyMemo;
  var childIsSubmittedMemo;
  var childrenAreValidMemo;
  var childrenAreDisabledMemo;
  var childrenAreReadonlyMemo;
  var childrenAreRequiredMemo;
  var childrenArePendingMemo;
  var childrenAreTouchedMemo;
  var childrenAreDirtyMemo;
  var childrenAreSubmittedMemo;
  var errorsMemo;
  var childrenErrorsMemo;
  var containerBase = mergeObj(base, {
    get size() {
      var _sizeMemo, _sizeMemo2;

      return (_sizeMemo = (_sizeMemo2 = sizeMemo) === null || _sizeMemo2 === void 0 ? void 0 : _sizeMemo2()) !== null && _sizeMemo !== void 0 ? _sizeMemo : untilInit(0);
    },

    get isDisabled() {
      return this.self.isDisabled || this.children.areDisabled;
    },

    get isTouched() {
      return this.self.isTouched || this.child.isTouched;
    },

    get isDirty() {
      return this.self.isDirty || this.child.isDirty;
    },

    get isReadonly() {
      return this.self.isReadonly || this.children.areReadonly;
    },

    get isSubmitted() {
      return this.self.isSubmitted || this.children.areSubmitted;
    },

    get isRequired() {
      return this.self.isRequired || this.child.isRequired;
    },

    get isPending() {
      return this.self.isPending || this.child.isPending;
    },

    get errors() {
      var _errorsMemo, _errorsMemo2;

      return (_errorsMemo = (_errorsMemo2 = errorsMemo) === null || _errorsMemo2 === void 0 ? void 0 : _errorsMemo2()) !== null && _errorsMemo !== void 0 ? _errorsMemo : untilInit(null);
    },

    get isValid() {
      return this.self.isValid && this.children.areValid;
    },

    child: {
      /** Will return true if *any* `enabled` direct child control is `valid` */
      get isValid() {
        var _childIsValidMemo, _childIsValidMemo2;

        return (_childIsValidMemo = (_childIsValidMemo2 = childIsValidMemo) === null || _childIsValidMemo2 === void 0 ? void 0 : _childIsValidMemo2()) !== null && _childIsValidMemo !== void 0 ? _childIsValidMemo : untilInit(true);
      },

      /** Will return true if *any* direct child control is `disabled` */
      get isDisabled() {
        var _childIsDisabledMemo, _childIsDisabledMemo2;

        return (_childIsDisabledMemo = (_childIsDisabledMemo2 = childIsDisabledMemo) === null || _childIsDisabledMemo2 === void 0 ? void 0 : _childIsDisabledMemo2()) !== null && _childIsDisabledMemo !== void 0 ? _childIsDisabledMemo : untilInit(false);
      },

      /** Will return true if *any* `enabled` direct child control is `readonly` */
      get isReadonly() {
        var _childIsReadonlyMemo, _childIsReadonlyMemo2;

        return (_childIsReadonlyMemo = (_childIsReadonlyMemo2 = childIsReadonlyMemo) === null || _childIsReadonlyMemo2 === void 0 ? void 0 : _childIsReadonlyMemo2()) !== null && _childIsReadonlyMemo !== void 0 ? _childIsReadonlyMemo : untilInit(false);
      },

      /** Will return true if *any* `enabled` direct child control is `required` */
      get isRequired() {
        var _childIsRequiredMemo, _childIsRequiredMemo2;

        return (_childIsRequiredMemo = (_childIsRequiredMemo2 = childIsRequiredMemo) === null || _childIsRequiredMemo2 === void 0 ? void 0 : _childIsRequiredMemo2()) !== null && _childIsRequiredMemo !== void 0 ? _childIsRequiredMemo : untilInit(false);
      },

      /** Will return true if *any* `enabled` direct child control is `pending` */
      get isPending() {
        var _childIsPendingMemo, _childIsPendingMemo2;

        return (_childIsPendingMemo = (_childIsPendingMemo2 = childIsPendingMemo) === null || _childIsPendingMemo2 === void 0 ? void 0 : _childIsPendingMemo2()) !== null && _childIsPendingMemo !== void 0 ? _childIsPendingMemo : untilInit(false);
      },

      /** Will return true if *any* `enabled` direct child control is `touched` */
      get isTouched() {
        var _childIsTouchedMemo, _childIsTouchedMemo2;

        return (_childIsTouchedMemo = (_childIsTouchedMemo2 = childIsTouchedMemo) === null || _childIsTouchedMemo2 === void 0 ? void 0 : _childIsTouchedMemo2()) !== null && _childIsTouchedMemo !== void 0 ? _childIsTouchedMemo : untilInit(false);
      },

      /** Will return true if *any* `enabled` direct child control is `dirty` */
      get isDirty() {
        var _childIsDirtyMemo, _childIsDirtyMemo2;

        return (_childIsDirtyMemo = (_childIsDirtyMemo2 = childIsDirtyMemo) === null || _childIsDirtyMemo2 === void 0 ? void 0 : _childIsDirtyMemo2()) !== null && _childIsDirtyMemo !== void 0 ? _childIsDirtyMemo : untilInit(false);
      },

      /** Will return true if *any* `enabled` direct child control is `submitted` */
      get isSubmitted() {
        var _childIsSubmittedMemo, _childIsSubmittedMemo2;

        return (_childIsSubmittedMemo = (_childIsSubmittedMemo2 = childIsSubmittedMemo) === null || _childIsSubmittedMemo2 === void 0 ? void 0 : _childIsSubmittedMemo2()) !== null && _childIsSubmittedMemo !== void 0 ? _childIsSubmittedMemo : untilInit(false);
      }

    },
    children: {
      /** Will return true if *all* `enabled` direct child control's are `valid` */
      get areValid() {
        var _childrenAreValidMemo, _childrenAreValidMemo2;

        return (_childrenAreValidMemo = (_childrenAreValidMemo2 = childrenAreValidMemo) === null || _childrenAreValidMemo2 === void 0 ? void 0 : _childrenAreValidMemo2()) !== null && _childrenAreValidMemo !== void 0 ? _childrenAreValidMemo : untilInit(true);
      },

      /** Will return true if *all* direct child control's are `disabled` */
      get areDisabled() {
        var _childrenAreDisabledM, _childrenAreDisabledM2;

        return (_childrenAreDisabledM = (_childrenAreDisabledM2 = childrenAreDisabledMemo) === null || _childrenAreDisabledM2 === void 0 ? void 0 : _childrenAreDisabledM2()) !== null && _childrenAreDisabledM !== void 0 ? _childrenAreDisabledM : untilInit(false);
      },

      /** Will return true if *all* `enabled` direct child control's are `readonly` */
      get areReadonly() {
        var _childrenAreReadonlyM, _childrenAreReadonlyM2;

        return (_childrenAreReadonlyM = (_childrenAreReadonlyM2 = childrenAreReadonlyMemo) === null || _childrenAreReadonlyM2 === void 0 ? void 0 : _childrenAreReadonlyM2()) !== null && _childrenAreReadonlyM !== void 0 ? _childrenAreReadonlyM : untilInit(false);
      },

      /** Will return true if *all* `enabled` direct child control's are `required` */
      get areRequired() {
        var _childrenAreRequiredM, _childrenAreRequiredM2;

        return (_childrenAreRequiredM = (_childrenAreRequiredM2 = childrenAreRequiredMemo) === null || _childrenAreRequiredM2 === void 0 ? void 0 : _childrenAreRequiredM2()) !== null && _childrenAreRequiredM !== void 0 ? _childrenAreRequiredM : untilInit(false);
      },

      /** Will return true if *all* `enabled` direct child control's are `pending` */
      get arePending() {
        var _childrenArePendingMe, _childrenArePendingMe2;

        return (_childrenArePendingMe = (_childrenArePendingMe2 = childrenArePendingMemo) === null || _childrenArePendingMe2 === void 0 ? void 0 : _childrenArePendingMe2()) !== null && _childrenArePendingMe !== void 0 ? _childrenArePendingMe : untilInit(false);
      },

      /** Will return true if *all* `enabled` direct child control's are `touched` */
      get areTouched() {
        var _childrenAreTouchedMe, _childrenAreTouchedMe2;

        return (_childrenAreTouchedMe = (_childrenAreTouchedMe2 = childrenAreTouchedMemo) === null || _childrenAreTouchedMe2 === void 0 ? void 0 : _childrenAreTouchedMe2()) !== null && _childrenAreTouchedMe !== void 0 ? _childrenAreTouchedMe : untilInit(false);
      },

      /** Will return true if *all* `enabled` direct child control's are `dirty` */
      get areDirty() {
        var _childrenAreDirtyMemo, _childrenAreDirtyMemo2;

        return (_childrenAreDirtyMemo = (_childrenAreDirtyMemo2 = childrenAreDirtyMemo) === null || _childrenAreDirtyMemo2 === void 0 ? void 0 : _childrenAreDirtyMemo2()) !== null && _childrenAreDirtyMemo !== void 0 ? _childrenAreDirtyMemo : untilInit(false);
      },

      /** Will return true if *all* `enabled` direct child control's are `submitted` */
      get areSubmitted() {
        var _childrenAreSubmitted, _childrenAreSubmitted2;

        return (_childrenAreSubmitted = (_childrenAreSubmitted2 = childrenAreSubmittedMemo) === null || _childrenAreSubmitted2 === void 0 ? void 0 : _childrenAreSubmitted2()) !== null && _childrenAreSubmitted !== void 0 ? _childrenAreSubmitted : untilInit(false);
      },

      /** Contains *all* `enabled` child control errors or `null` if there are none */
      get errors() {
        var _childrenErrorsMemo, _childrenErrorsMemo2;

        return (_childrenErrorsMemo = (_childrenErrorsMemo2 = childrenErrorsMemo) === null || _childrenErrorsMemo2 === void 0 ? void 0 : _childrenErrorsMemo2()) !== null && _childrenErrorsMemo !== void 0 ? _childrenErrorsMemo : untilInit(null);
      },

      markDirty: function markDirty(value, options) {
        solidJs.batch(function () {
          Object.values(control.controls).forEach(function (c) {
            c.markDirty(value);

            if (!(options !== null && options !== void 0 && options.deep) || !isAbstractControlContainer(c)) {
              return;
            }

            c.children.markDirty(value, options);
          });
        });
      },
      markDisabled: function markDisabled(value, options) {
        solidJs.batch(function () {
          Object.values(control.controls).forEach(function (c) {
            c.markDisabled(value);

            if (!(options !== null && options !== void 0 && options.deep) || !isAbstractControlContainer(c)) {
              return;
            }

            c.children.markDisabled(value, options);
          });
        });
      },
      markPending: function markPending(value, options) {
        solidJs.batch(function () {
          Object.values(control.controls).forEach(function (c) {
            c.markPending(value, options);

            if (!(options !== null && options !== void 0 && options.deep) || !isAbstractControlContainer(c)) {
              return;
            }

            c.children.markPending(value, options);
          });
        });
      },
      markReadonly: function markReadonly(value, options) {
        solidJs.batch(function () {
          Object.values(control.controls).forEach(function (c) {
            c.markReadonly(value);

            if (!(options !== null && options !== void 0 && options.deep) || !isAbstractControlContainer(c)) {
              return;
            }

            c.children.markReadonly(value, options);
          });
        });
      },
      markRequired: function markRequired(value, options) {
        solidJs.batch(function () {
          Object.values(control.controls).forEach(function (c) {
            c.markRequired(value);

            if (!(options !== null && options !== void 0 && options.deep) || !isAbstractControlContainer(c)) {
              return;
            }

            c.children.markRequired(value, options);
          });
        });
      },
      markSubmitted: function markSubmitted(value, options) {
        solidJs.batch(function () {
          Object.values(control.controls).forEach(function (c) {
            c.markSubmitted(value);

            if (!(options !== null && options !== void 0 && options.deep) || !isAbstractControlContainer(c)) {
              return;
            }

            c.children.markSubmitted(value, options);
          });
        });
      },
      markTouched: function markTouched(value, options) {
        solidJs.batch(function () {
          Object.values(control.controls).forEach(function (c) {
            c.markTouched(value);

            if (!(options !== null && options !== void 0 && options.deep) || !isAbstractControlContainer(c)) {
              return;
            }

            c.children.markTouched(value, options);
          });
        });
      }
    },
    setControls: function setControls(controls) {
      if (isEqual(control.controls, controls)) return; // We're using `produce()` here because using the standard solid Store
      // nested setter has some bugs (i.e.
      // `setControl('self', 'pendingStore', newPendingStore)`). I think the
      // bugs are isolated to object values, so, at the moment, I'm only using
      // produce where the value is an object.

      setControl(store.produce(function (state) {
        state.controls = controls;
      }));
    },

    /**
     * The provided control is removed from this FormGroup
     * if it is a child of this FormGroup. Or the control
     * associated with the provided key is removed.
     */
    removeControl: function removeControl(keyOrControl) {
      if (!isAbstractControl(keyOrControl)) {
        control.setControl(keyOrControl, null);
        return;
      }

      var childControl = keyOrControl;

      for (var _i = 0, _Object$entries = Object.entries(control.controls); _i < _Object$entries.length; _i++) {
        var _Object$entries$_i = _slicedToArray(_Object$entries[_i], 2),
            key = _Object$entries$_i[0],
            c = _Object$entries$_i[1];

        if (c !== childControl) continue;
        control.setControl(key, null);
        return;
      }
    },
    setValue: function setValue(value) {
      var valueEntries = Object.entries(value);

      if (valueEntries.length !== control.size) {
        throw new Error("setValue error: you must provide a value for each control.");
      }

      solidJs.batch(function () {
        var _iterator = _createForOfIteratorHelper(valueEntries),
            _step;

        try {
          for (_iterator.s(); !(_step = _iterator.n()).done;) {
            var _step$value = _slicedToArray(_step.value, 2),
                key = _step$value[0],
                val = _step$value[1];

            var c = control.controls[key];

            if (!c) {
              throw new Error("Invalid setValue value key \"".concat(key, "\"."));
            }

            c.setValue(val);
          }
        } catch (err) {
          _iterator.e(err);
        } finally {
          _iterator.f();
        }
      });
    },
    patchValue: function patchValue(value) {
      solidJs.batch(function () {
        for (var _i2 = 0, _Object$entries2 = Object.entries(value); _i2 < _Object$entries2.length; _i2++) {
          var _Object$entries2$_i = _slicedToArray(_Object$entries2[_i2], 2),
              key = _Object$entries2$_i[0],
              entryValue = _Object$entries2$_i[1];

          var c = control.controls[key];

          if (!c) {
            throw new Error("Invalid patchValue value key \"".concat(key, "\"."));
          }

          if (isAbstractControlContainer(c)) {
            c.patchValue(entryValue);
          } else {
            c.setValue(entryValue);
          }
        }
      });
    }
  });

  var initializer = function initializer() {
    var _store = store$1();

    var _store2 = _slicedToArray(_store, 2);

    control = _store2[0];
    setControl = _store2[1];
    initializeAbstractControl();
    var allControlsMemo = solidJs.createMemo(function () {
      return Object.values(control.controls);
    });
    var nonDisabledControlsMemo = solidJs.createMemo(function () {
      return allControlsMemo().filter(function (c) {
        return !c.isDisabled;
      });
    });
    sizeMemo = solidJs.createMemo(function () {
      return allControlsMemo().length;
    });
    childIsValidMemo = solidJs.createMemo(function () {
      return nonDisabledControlsMemo().some(function (c) {
        return c.isValid;
      });
    });
    childIsDisabledMemo = solidJs.createMemo(function () {
      return allControlsMemo().some(function (c) {
        return c.isDisabled;
      });
    });
    childIsReadonlyMemo = solidJs.createMemo(function () {
      return nonDisabledControlsMemo().some(function (c) {
        return c.isReadonly;
      });
    });
    childIsRequiredMemo = solidJs.createMemo(function () {
      return nonDisabledControlsMemo().some(function (c) {
        return c.isRequired;
      });
    });
    childIsPendingMemo = solidJs.createMemo(function () {
      return nonDisabledControlsMemo().some(function (c) {
        return c.isPending;
      });
    });
    childIsTouchedMemo = solidJs.createMemo(function () {
      return nonDisabledControlsMemo().some(function (c) {
        return c.isTouched;
      });
    });
    childIsDirtyMemo = solidJs.createMemo(function () {
      return nonDisabledControlsMemo().some(function (c) {
        return c.isDirty;
      });
    });
    childIsSubmittedMemo = solidJs.createMemo(function () {
      return nonDisabledControlsMemo().some(function (c) {
        return c.isSubmitted;
      });
    });
    childrenAreValidMemo = solidJs.createMemo(function () {
      return nonDisabledControlsMemo().every(function (c) {
        return c.isValid;
      });
    });
    childrenAreDisabledMemo = solidJs.createMemo(function () {
      var controls = allControlsMemo();
      if (controls.length === 0) return false;
      return controls.every(function (c) {
        return c.isDisabled;
      });
    });
    childrenAreReadonlyMemo = solidJs.createMemo(function () {
      var controls = nonDisabledControlsMemo();
      if (controls.length === 0) return false;
      return controls.every(function (c) {
        return c.isReadonly;
      });
    });
    childrenAreRequiredMemo = solidJs.createMemo(function () {
      var controls = nonDisabledControlsMemo();
      if (controls.length === 0) return false;
      return controls.every(function (c) {
        return c.isRequired;
      });
    });
    childrenArePendingMemo = solidJs.createMemo(function () {
      var controls = nonDisabledControlsMemo();
      if (controls.length === 0) return false;
      return controls.every(function (c) {
        return c.isPending;
      });
    });
    childrenAreTouchedMemo = solidJs.createMemo(function () {
      var controls = nonDisabledControlsMemo();
      if (controls.length === 0) return false;
      return controls.every(function (c) {
        return c.isTouched;
      });
    });
    childrenAreDirtyMemo = solidJs.createMemo(function () {
      var controls = nonDisabledControlsMemo();
      if (controls.length === 0) return false;
      return controls.every(function (c) {
        return c.isDirty;
      });
    });
    childrenAreSubmittedMemo = solidJs.createMemo(function () {
      var controls = nonDisabledControlsMemo();
      if (controls.length === 0) return false;
      return controls.every(function (c) {
        return c.isSubmitted;
      });
    });
    errorsMemo = solidJs.createMemo(function () {
      if (!control.self.errors && !control.children.errors) return null;
      return _objectSpread2(_objectSpread2({}, control.children.errors), control.self.errors);
    });
    childrenErrorsMemo = solidJs.createMemo(function () {
      var controls = nonDisabledControlsMemo();
      return controls.reduce(function (prev, curr) {
        return prev === null && curr.errors === null ? null : _objectSpread2(_objectSpread2({}, prev), curr.errors);
      }, null);
    });
  };

  return [containerBase, initializer];
}

var FormGroupInterface = '@@FormGroupInterface_solidjs';

/**
 * Returns true if the provided object implements
 * `IFormGroup`
 */
function isFormGroup(object) {
  return isAbstractControlContainer(object) && (object === null || object === void 0 ? void 0 : object[FormGroupInterface]) === true;
}
function createFormGroup() {
  var _rawValue, _value, _mergeObj, _mutatorMap;

  var initControls = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var initOptions = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var control;

  var _setControl;

  var _propInitializer = propInitializer(),
      _propInitializer2 = _slicedToArray(_propInitializer, 2),
      untilInit = _propInitializer2[0],
      initComplete = _propInitializer2[1];

  var _createAbstractContro = createAbstractControlContainerBase(function () {
    return [control, _setControl];
  }, untilInit, initOptions),
      _createAbstractContro2 = _slicedToArray(_createAbstractContro, 2),
      base = _createAbstractContro2[0],
      initializeBase = _createAbstractContro2[1];

  var rawValueMemo;
  var valueMemo;
  var storeConfig = mergeObj(base, (_mergeObj = {}, _defineProperty(_mergeObj, AbstractControlInterface, true), _defineProperty(_mergeObj, AbstractControlContainerInterface, true), _defineProperty(_mergeObj, FormGroupInterface, true), _defineProperty(_mergeObj, "controls", initControls), _rawValue = "rawValue", _mutatorMap = {}, _mutatorMap[_rawValue] = _mutatorMap[_rawValue] || {}, _mutatorMap[_rawValue].get = function () {
    var _rawValueMemo, _rawValueMemo2;

    return (_rawValueMemo = (_rawValueMemo2 = rawValueMemo) === null || _rawValueMemo2 === void 0 ? void 0 : _rawValueMemo2()) !== null && _rawValueMemo !== void 0 ? _rawValueMemo : untilInit({});
  }, _value = "value", _mutatorMap[_value] = _mutatorMap[_value] || {}, _mutatorMap[_value].get = function () {
    var _valueMemo, _valueMemo2;

    return (_valueMemo = (_valueMemo2 = valueMemo) === null || _valueMemo2 === void 0 ? void 0 : _valueMemo2()) !== null && _valueMemo !== void 0 ? _valueMemo : untilInit({});
  }, _defineProperty(_mergeObj, "setControl", function setControl(key, newControl) {
    if (newControl === null ? !control.controls[key] : isEqual(control.controls[key], newControl)) {
      return;
    }

    _setControl(store.produce(function (state) {
      if (newControl === null) {
        delete state.controls[key];
      } else {
        state.controls[key] = newControl;
      }
    }));
  }), _defineEnumerableProperties(_mergeObj, _mutatorMap), _mergeObj));

  var _createStore = store.createStore(storeConfig);

  var _createStore2 = _slicedToArray(_createStore, 2);

  control = _createStore2[0];
  _setControl = _createStore2[1];
  initializeBase();
  var allControlEntriesMemo = solidJs.createMemo(function () {
    return Object.entries(control.controls);
  });
  var enabledControlEntriesMemo = solidJs.createMemo(function () {
    return allControlEntriesMemo().filter(function (_ref) {
      var _ref2 = _slicedToArray(_ref, 2),
          c = _ref2[1];

      return !c.isDisabled;
    });
  });
  rawValueMemo = solidJs.createMemo(function () {
    return Object.fromEntries(allControlEntriesMemo().map(function (_ref3) {
      var _ref4 = _slicedToArray(_ref3, 2),
          k = _ref4[0],
          c = _ref4[1];

      return [k, c.rawValue];
    }));
  });
  valueMemo = solidJs.createMemo(function () {
    return Object.fromEntries(enabledControlEntriesMemo().map(function (_ref5) {
      var _ref6 = _slicedToArray(_ref5, 2),
          k = _ref6[0],
          c = _ref6[1];

      return [k, c.value];
    }));
  });
  initComplete(); // Intentionally not using `batch()` since it appears to mess with
  // initializing a control with errors

  if (initOptions.disabled) control.markDisabled(initOptions.disabled);
  if (initOptions.touched) control.markTouched(initOptions.touched);
  if (initOptions.dirty) control.markDirty(initOptions.dirty);
  if (initOptions.readonly) control.markReadonly(initOptions.readonly);
  if (initOptions.submitted) control.markSubmitted(initOptions.submitted);
  if (initOptions.required) control.markRequired(initOptions.required);
  if (initOptions.pending) control.markPending(initOptions.pending);
  if (initOptions.validators) control.setValidators(initOptions.validators);
  if (initOptions.pending) control.markPending(initOptions.pending); // this needs to be last to ensure that the errors aren't overwritten

  if (initOptions.errors) control.patchErrors(initOptions.errors);
  return control;
}

var FormArrayInterface = '@@FormArrayInterface_solidjs';

/**
 * Returns true if the provided object implements
 * `IFormArray`
 */
function isFormArray(object) {
  return isAbstractControlContainer(object) && (object === null || object === void 0 ? void 0 : object[FormArrayInterface]) === true;
}
function createFormArray() {
  var _rawValue, _value, _mergeObj, _mutatorMap;

  var initControls = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  var initOptions = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var control;

  var _setControl;

  var _propInitializer = propInitializer(),
      _propInitializer2 = _slicedToArray(_propInitializer, 2),
      untilInit = _propInitializer2[0],
      initComplete = _propInitializer2[1];

  var _createAbstractContro = createAbstractControlContainerBase(function () {
    return [control, _setControl];
  }, untilInit, initOptions),
      _createAbstractContro2 = _slicedToArray(_createAbstractContro, 2),
      base = _createAbstractContro2[0],
      initializeBase = _createAbstractContro2[1];

  var rawValueMemo;
  var valueMemo;
  var storeConfig = mergeObj(base, (_mergeObj = {}, _defineProperty(_mergeObj, AbstractControlInterface, true), _defineProperty(_mergeObj, AbstractControlContainerInterface, true), _defineProperty(_mergeObj, FormArrayInterface, true), _defineProperty(_mergeObj, "controls", initControls), _rawValue = "rawValue", _mutatorMap = {}, _mutatorMap[_rawValue] = _mutatorMap[_rawValue] || {}, _mutatorMap[_rawValue].get = function () {
    var _rawValueMemo, _rawValueMemo2;

    return (_rawValueMemo = (_rawValueMemo2 = rawValueMemo) === null || _rawValueMemo2 === void 0 ? void 0 : _rawValueMemo2()) !== null && _rawValueMemo !== void 0 ? _rawValueMemo : untilInit({});
  }, _value = "value", _mutatorMap[_value] = _mutatorMap[_value] || {}, _mutatorMap[_value].get = function () {
    var _valueMemo, _valueMemo2;

    return (_valueMemo = (_valueMemo2 = valueMemo) === null || _valueMemo2 === void 0 ? void 0 : _valueMemo2()) !== null && _valueMemo !== void 0 ? _valueMemo : untilInit({});
  }, _defineProperty(_mergeObj, "setControl", function setControl(key, newControl) {
    if (newControl === null ? !control.controls[key] : isEqual(control.controls[key], newControl)) {
      return;
    }

    _setControl(store.produce(function (state) {
      if (newControl === null) {
        state.controls.splice(key, 1);
      } else {
        state.controls[key] = newControl;
      }
    }));
  }), _defineProperty(_mergeObj, "push", function push(control) {
    this.setControl(this.controls.length, control);
  }), _defineEnumerableProperties(_mergeObj, _mutatorMap), _mergeObj));

  var _createStore = store.createStore(storeConfig);

  var _createStore2 = _slicedToArray(_createStore, 2);

  control = _createStore2[0];
  _setControl = _createStore2[1];
  initializeBase();
  var enabledControlsMemo = solidJs.createMemo(function () {
    return control.controls.filter(function (c) {
      return !c.isDisabled;
    });
  });
  rawValueMemo = solidJs.createMemo(function () {
    return control.controls.map(function (c) {
      return c.rawValue;
    });
  });
  valueMemo = solidJs.createMemo(function () {
    return enabledControlsMemo().map(function (c) {
      return c.value;
    });
  });
  initComplete(); // Intentionally not using `batch()` since it appears to mess with
  // initializing a control with errors

  if (initOptions.disabled) control.markDisabled(initOptions.disabled);
  if (initOptions.touched) control.markTouched(initOptions.touched);
  if (initOptions.dirty) control.markDirty(initOptions.dirty);
  if (initOptions.readonly) control.markReadonly(initOptions.readonly);
  if (initOptions.submitted) control.markSubmitted(initOptions.submitted);
  if (initOptions.required) control.markRequired(initOptions.required);
  if (initOptions.pending) control.markPending(initOptions.pending);
  if (initOptions.validators) control.setValidators(initOptions.validators);
  if (initOptions.pending) control.markPending(initOptions.pending); // this needs to be last to ensure that the errors aren't overwritten

  if (initOptions.errors) control.patchErrors(initOptions.errors);
  return control;
}

exports.AbstractControlContainerInterface = AbstractControlContainerInterface;
exports.AbstractControlInterface = AbstractControlInterface;
exports.DEFAULT_SOURCE = DEFAULT_SOURCE;
exports.FormArrayInterface = FormArrayInterface;
exports.FormControlInterface = FormControlInterface;
exports.FormGroupInterface = FormGroupInterface;
exports.bindOwner = bindOwner;
exports.composeValidators = composeValidators;
exports.createAbstractControlBase = createAbstractControlBase;
exports.createAbstractControlContainerBase = createAbstractControlContainerBase;
exports.createFormArray = createFormArray;
exports.createFormControl = createFormControl;
exports.createFormGroup = createFormGroup;
exports.isAbstractControl = isAbstractControl;
exports.isAbstractControlContainer = isAbstractControlContainer;
exports.isFormArray = isFormArray;
exports.isFormControl = isFormControl;
exports.isFormGroup = isFormGroup;
//# sourceMappingURL=index.common.js.map
