'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var core = require('solid-forms/core');
var web = require('solid-js/web');
var solidJs = require('solid-js');

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function withControl(options) {
  var prefix = options.classListPrefix || "sf";

  var wrappedComponent = function wrappedComponent(props) {
    var control = solidJs.createMemo(function () {
      return props.control || solidJs.createRoot(function () {
        return options.controlFactory(props);
      });
    });
    var controlClassList = solidJs.createMemo(function () {
      return createClassList(control(), prefix);
    });
    var Component = options.component;
    return web.createComponent(Component, web.mergeProps(props, {
      get control() {
        return control();
      },

      controlClassList: controlClassList
    }));
  };

  wrappedComponent.control = options.controlFactory;
  return wrappedComponent;
}
function createClassList(control) {
  var _ref;

  var prefix = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "sf";
  return _ref = {}, _defineProperty(_ref, "".concat(prefix, "-control-container"), core.isAbstractControlContainer(control)), _defineProperty(_ref, "".concat(prefix, "-valid"), control.isValid), _defineProperty(_ref, "".concat(prefix, "-invalid"), !control.isValid), _defineProperty(_ref, "".concat(prefix, "-dirty"), control.isDirty), _defineProperty(_ref, "".concat(prefix, "-not-dirty"), !control.isDirty), _defineProperty(_ref, "".concat(prefix, "-touched"), control.isTouched), _defineProperty(_ref, "".concat(prefix, "-untouched"), !control.isTouched), _defineProperty(_ref, "".concat(prefix, "-pending"), control.isPending), _defineProperty(_ref, "".concat(prefix, "-not-pending"), !control.isPending), _defineProperty(_ref, "".concat(prefix, "-disabled"), control.isDisabled), _defineProperty(_ref, "".concat(prefix, "-enabled"), !control.isDisabled), _defineProperty(_ref, "".concat(prefix, "-editable"), !control.isReadonly), _defineProperty(_ref, "".concat(prefix, "-readonly"), control.isReadonly), _defineProperty(_ref, "".concat(prefix, "-optional"), !control.isRequired), _defineProperty(_ref, "".concat(prefix, "-required"), control.isRequired), _defineProperty(_ref, "".concat(prefix, "-submitted"), control.isSubmitted), _defineProperty(_ref, "".concat(prefix, "-not-submitted"), !control.isSubmitted), _ref;
}

exports.createClassList = createClassList;
exports.withControl = withControl;
Object.keys(core).forEach(function (k) {
  if (k !== 'default' && !exports.hasOwnProperty(k)) Object.defineProperty(exports, k, {
    enumerable: true,
    get: function () { return core[k]; }
  });
});
//# sourceMappingURL=index.common.js.map
