import { isAbstractControlContainer } from 'solid-forms/core';
export * from 'solid-forms/core';
import { createComponent, mergeProps } from 'solid-js/web';
import { createMemo, createRoot } from 'solid-js';

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function withControl(options) {
  var prefix = options.classListPrefix || "sf";

  var wrappedComponent = function wrappedComponent(props) {
    var control = createMemo(function () {
      return props.control || createRoot(function () {
        return options.controlFactory(props);
      });
    });
    var controlClassList = createMemo(function () {
      return createClassList(control(), prefix);
    });
    var Component = options.component;
    return createComponent(Component, mergeProps(props, {
      get control() {
        return control();
      },

      controlClassList: controlClassList
    }));
  };

  wrappedComponent.control = options.controlFactory;
  return wrappedComponent;
}
function createClassList(control) {
  var _ref;

  var prefix = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "sf";
  return _ref = {}, _defineProperty(_ref, "".concat(prefix, "-control-container"), isAbstractControlContainer(control)), _defineProperty(_ref, "".concat(prefix, "-valid"), control.isValid), _defineProperty(_ref, "".concat(prefix, "-invalid"), !control.isValid), _defineProperty(_ref, "".concat(prefix, "-dirty"), control.isDirty), _defineProperty(_ref, "".concat(prefix, "-not-dirty"), !control.isDirty), _defineProperty(_ref, "".concat(prefix, "-touched"), control.isTouched), _defineProperty(_ref, "".concat(prefix, "-untouched"), !control.isTouched), _defineProperty(_ref, "".concat(prefix, "-pending"), control.isPending), _defineProperty(_ref, "".concat(prefix, "-not-pending"), !control.isPending), _defineProperty(_ref, "".concat(prefix, "-disabled"), control.isDisabled), _defineProperty(_ref, "".concat(prefix, "-enabled"), !control.isDisabled), _defineProperty(_ref, "".concat(prefix, "-editable"), !control.isReadonly), _defineProperty(_ref, "".concat(prefix, "-readonly"), control.isReadonly), _defineProperty(_ref, "".concat(prefix, "-optional"), !control.isRequired), _defineProperty(_ref, "".concat(prefix, "-required"), control.isRequired), _defineProperty(_ref, "".concat(prefix, "-submitted"), control.isSubmitted), _defineProperty(_ref, "".concat(prefix, "-not-submitted"), !control.isSubmitted), _ref;
}

export { createClassList, withControl };
//# sourceMappingURL=index.module.js.map
